# Generated by Django 3.0.6 on 2020-05-07 02:46

from django.db import migrations
from django.conf import settings
import pandas as pd

from spbstu.utils import get_year


def create_student(student, apps):
    Institute = apps.get_model('spbstu', 'Institute')
    Department = apps.get_model('spbstu', 'Department')
    Group = apps.get_model('spbstu', 'Group')
    EducationForm = apps.get_model('spbstu', 'EducationForm')
    Student = apps.get_model('spbstu', 'Student')
    Status = apps.get_model('spbstu', 'Status')

    columns = student.split(',')
    columns = [column.replace('"', '').strip() for column in columns[1:]]

    institute, _ = Institute.objects.get_or_create(name=columns[7])
    department, _ = Department.objects.get_or_create(
        institute=institute, name=columns[8], base_num=columns[9], ext_num=columns[10]
    )
    group, _ = Group.objects.get_or_create(department=department, number=columns[4], year=get_year(int(columns[5])))
    education_form, _ = EducationForm.objects.get_or_create(name=columns[12])
    day, month, year = columns[3].split('.')

    return Student.objects.create(
        last_name=columns[0],
        first_name=columns[1],
        patronymic=columns[2],
        birth_date='-'.join([year, month, day]),
        group=group,
        record_number=columns[6],
        is_contract=columns[11] == 'Контракт',
        education_form=education_form,
        status=Status.objects.get(name=columns[13]),
        nationality=columns[14],
        document=columns[15],
        document_number=columns[16],
        gender=0 if columns[17] == 'Мужской' else 1,
    )


def fill_students(apps, schema_editor):
    data = pd.read_excel(settings.DB_EXCEL_DIR / 'Students.xlsx', 'vshpi', header=None)
    data_str = data.to_string(header=False, index=False).splitlines()
    for row in data_str:
        try:
            create_student(row, apps)
        except Exception as e:
            print(e)


def drop_students(apps, schema_editor):
    Student = apps.get_model('spbstu', 'Student')
    Student.objects.all().delete()


class Migration(migrations.Migration):
    dependencies = [
        ('spbstu', '0005_auto_20200507_0545'),
    ]

    operations = [
        migrations.RunPython(fill_students, drop_students)
    ]
